x = 30   // horizontal position of the ball
y = 300  // vertical position of the ball
         // initialized to the starting position
s = 0    // speed of ball initialized to zero
g = .1   // our guess at our gravity factor
El = 1   //elasticity factor
wind = 1 //wind speed
flip on
while true
   x = x+wind  
   if not within(x,0,780) //reached left or right 
     wind = -wind         //reverse wind
     if x<0 then x=0   //no move beyond limits
     if x>780 then x=780
   endif
   circle x,y,x+20,y+20,red,black // draw ball
   flip
   circle x,y,x+20,y+20,white,white // erase ball
   y = y+s // calculate the new ball position
   s = s+g // calculate the new speed
   // now reverse the ball if it hits the ground
   // by making the speed negative
   if y>580 
      y=580    //don't let it go too far
      s= -s*El //reverse and slow down
   endif   
   // note: Round off errors can cause the ball
   // to bounce higher and higher
   // if you run the program awhile....
   // the line below corrects that
   if y<300 then y=300
wend
end
