MainProgram:
  gosub Initialization
  while True
    ReadMouse a,b,c
    if a<125
      gosub ProcessMenu
    else
      gosub DrawBrush
    endif
  wend
end

Initialization:
  Print "RobotBASIC PAINT PROGRAM"
  Print "discussed in RobotBASIC"
  Print "Projects for Beginners"
  Print
  Print "   www.RobotBASIC.com"
  Print 
  Print "Hold down left-button to draw"
  Print
  Print "Choose from menu with Mouse"
  Print
  Print "Rt-click colors to redefine"
  Print "any color."
  Print
  Print "Rt-click open brushes to make"
  Print "The current color, the new"
  Print "background color."
  Print 
  Print "Choose Fill to fill with current"
  Print "color, then click in area to fill."
  Print
  Print "     Press any key"
  waitkey x
  ClearScr
  co = 0
  br = 2
  bc = 7
  ClearScr bc
  Dim Col[10]
  for i=0 to 9
    Col[i]=i
  next
  gosub DrawMenu
return

DrawMenu:
  LineWidth 3
  c=0
  for i=0 to 540 step 60
    Rectangle 1,i,65,i+60,black,white
    Rectangle 65,i,125,i+60,black,Col[c]
    c=c+1
  next
  xyString 15,20,"OPEN"
  xyString 15,80,"SAVE"
  xyString 13,130,"FILL"
  xyString 8,190,"CLEAR"
  xyString 9,542,"BRUSH"
  s=2
  x=32
  y=270
  circle x-s,y-s,x+s,y+s,black,black
  s=6
  y=330
  circle x-s,y-s,x+s,y+s,black,black
  s=12
  y=390
  circle x-s,y-s,x+s,y+s,black,black 
  s=6
  y=450
  circle x-s,y-s,x+s,y+s,black,white
  s=12
  y=510
  circle x-s,y-s,x+s,y+s,black,white
  gosub Now
return

DrawBrush:
  // assumes br defines the brush and
  // co is the color
  // a,b,c are the mouse data
  while c=1
    if a>125
      if br<20
        s=br
        Circle a-s,b-s,a+s,b+s,Col[co],Col[co]
      else
        s=(br-20)
        Circle a-s,b-s,a+s,b+s,Col[co],Col[bc]
      endif
    endif
    ReadMouse a,b,c
  wend
return

ProcessMenu:
  ReadMouse a,b,c
  if a>125 or c=0 then return
  if within(a,60,125)
     // process color
     if c=1
       co = b/60
     elseif c=2
       Col[b/60]=PromptColor()
       gosub DrawMenu
     endif
  else
     if c=1
     // other menu item
       if within(b,240,300) then br=2
       if within(b,300,360) then br=6
       if within(b,360,420) then br=12
       if within(b,420,480) then br=26
       if within(b,480,540) then br=32
       if within(b,180,240)
         bc = co
         clearscr bc
         gosub DrawMenu
       endif
       if within(b,120,180)
         SetCursor -3
         repeat
           ReadMouse a,b,c
         until c=0
         repeat
           ReadMouse a,b,c
         until c=1
         if a>125 then FloodFill a,b,Col[co]
         SetCursor
       endif
       if within(b,0,60)
          Input "OPENING: Enter a File Name",fname
          if fname<>"" then ReadScr(fname)
          gosub DrawMenu
       endif
       if within(b,60,120)
          Input "SAVING: Enter a File Name",fname
          if fname<>"" then WriteScr(fname)
       endif
    elseif c=2
       // an open brush was right-clicked
       if within(b,420,540)
          // set the new background color
          bc = co
          // then set the new brush style
          if within(b,420,480) 
            br=26
          else 
            br=32
          endif
          gosub DrawMenu
       endif
    endif
  endif
  gosub Now
return


Now:
  Rectangle 10,150,55,170,Col[co],Col[co]
  Rectangle 10,210,55,230,Col[co],Col[co]
  a=32
  b=577
  s=12
  Circle a-s,b-s,a+s,b+s,white,white
  if br<20
    s=br
    Circle a-s,b-s,a+s,b+s,Col[co],Col[co]
  else
    s=(br-20)
    circle a-s,b-s,a+s,b+s,Col[co],Col[bc]
  endif  
return