// Use the mouse BUTTONS to draw objects
// to block the robot - do NOT draw an 
// object on top of the robot.

// create the robot near the
// center of the screen
size = 50
LineWidth 3
rLocate 400,300
rTurn 20
while True
   // move forward till bumped
   // note that the following WHILE was changed from the book
   // it allows the robot to move forward even if it is blocked
   // from behind (does not happen often, but it can happen)
   // Much more coverage of the robot can be found in our
   // "Bonanza" book... see www.RobotBASIC.com
   while rBumper()<2
      rForward 1
      // draw an object if mouse is clicked
      ReadMouse x,y,b
      if b=1 then Rectangle x,y,x+size,y+size
      if b=2 then Circle x,y,x+size,y+size
   wend
   bump = rBumper()
   // back up one pixel
   if rBumper() <> 1 then rForward -1
   // now turn away
   if bump = 2 or bump = 6 then rTurn -130
   if bump = 8 or bump = 12 then rTurn 130
   if bump = 4 or bump = 14 then rTurn 140+random(80)
   
wend
end
